// AuthService sisältää kirjautumiseen liittyvät palvelut

import { Injectable } from '@angular/core';

@Injectable({
  providedIn: 'root'
})
export class AuthService {
  
  // säilyttää tietoa siitä onko käyttäjä kirjautunut sisään vai ei
  isLoggedIn: boolean;

  constructor() {
    // aluksi kirjautuminen false, joten ei päästä guardilla suojatulle sivulle
    this.isLoggedIn = false;
  }

  /* luodaan localstorageen token, jossa on pelkkä username.
     sen avulla valitaan profiilisivulle oikeat tiedot. Sessionstorage
     voisi olla tietoturvan kannalta parempi varastopaikka, sillä
     sieltä tiedot lähtevät aina kun käyttäjä sulkee selaimen.

     Oikeassa sovelluksessa token luodaan backendissä (JWT-token), tai
     käytetään esim. Google-kirjautumisen yhteydessä Googlen lähettämää
     tokenia, jossa on esim. Googlen käyttäjätunnus. Oikea token ei ole
     suoraan ihmisen luettavissa, vaan tiedot pitää purkaa sieltä.
  */
  createtoken(username: string) :void {  
    localStorage.setItem('token', username);
  }
  removetoken() :void {        
    localStorage.removeItem('token');
    }    
  

}
