// Funktionaalinen guard, jolla suojataan reitti loggautumattomilta käyttäjiltä
import { inject } from '@angular/core';
import {
  ActivatedRouteSnapshot,
  createUrlTreeFromSnapshot,
} from '@angular/router';
import { AuthService } from './auth.service';

/*
loginGuard on ns. funktionaalinen guard, joka tuli käyttöön Angularin versiossa 15.
Jos AuthServicen property isLoggedIn on true, Guard palauttaa true, ja reitti
toimii. Jos isLoggedIn on false, Guard palauttaa reitin login-näkymään, jonne
mennään välittömästi.
*/

export const loginGuard = (next: ActivatedRouteSnapshot) => {
  return inject(AuthService).isLoggedIn
    ? true
    : createUrlTreeFromSnapshot(next, ['/', 'login']);
};
