/*
Login-komponentin TS-sovelluslogiikka
*/

import { Component, OnInit } from '@angular/core';
import { CommonModule } from '@angular/common';
import { Router } from '@angular/router';
import { AuthService } from '../auth.service';
import { Credential } from '../credential';
import { FormsModule } from '@angular/forms';
import { Credentialdata } from '../credentialdata';

@Component({
  selector: 'app-login',
  standalone: true,
  imports: [CommonModule, FormsModule],
  templateUrl: './login.component.html',
  styleUrls: ['./login.component.css'],
})
export class LoginComponent implements OnInit {
  creds: Credential[] = [];
  error: string = '';

  constructor(private router: Router, private authService: AuthService) {}

  ngOnInit(): void {
    /* Oikeassa sovelluksessa tunnareita ei tuoda sovellukseen,
     vaan kannasta haetaan tieto, onko niitä siellä (true tai false) */
    this.creds = Credentialdata;
  }
  // lomakkeelta saatujen tietojen vertailu kannassa oleviin tietoihin
  onSubmit(formdata: Credential, isvalid: boolean | null): void {
    if (isvalid) {
      // Katsotaan että lomakkeelle syötetyt tunnarit ovat "kannassa"
      const index = this.creds.findIndex(
        (x) => x.username === formdata.username
      );
      if (index != -1 && this.creds[index].password === formdata.password) {
        // autentikaatio on onnistunut
        // authservicessa muuttujan arvoksi tulee true
        this.authService.isLoggedIn = true;
        // luodaan localstorageen token, jonne laitetaan username
        this.authService.createtoken(formdata.username);
        // hypätään regformiin kun autentikaatio on onnistunut
        this.router.navigate(['/profile']);
        // muuten jos tunnarit väärät
      } else {
        this.error = 'Tunnus ja/tai salasana virheellinen';
      }
    }
  }
}
