/*
Profiilikomponentin sovelluslogiikka. Sovelluksessa on aina vain yksi näkymä
jokaiseen tarkoitukseen, kuten tietojen näyttämiseen, lisäämiseen, muokkaamiseen. 
Näihin näkymiin vaihdetaan tiedot käyttäjän profiilin perusteella. 
Profiilin tiedot saadaan haettua sivuille tokenista saatavan tiedon, 
eli tässä usernamen, avulla.

Jos tehtäisiin toinen "profiilisivu", niin siinä tarkistettaisiin ensin että 
isLoggedIn on true ja sitten sinne haettaisiin tokenista username samalla tavalla
kuin tälle sivulle, ja sitten sen avulla haettaisiin profiilitiedot "kannasta"
sivulle samalla tavalla kuin tässä.
*/
import { Component } from '@angular/core';
import { CommonModule } from '@angular/common';
import { Router } from '@angular/router';
import { AuthService } from '../auth.service';
import { Profiledata } from '../profiledata';
import { Profile } from '../profile';

@Component({
  selector: 'app-profile',
  standalone: true,
  imports: [CommonModule],
  templateUrl: './profile.component.html',
  styleUrls: ['./profile.component.css']
})
export class ProfileComponent {

  username: string | null;
  profile: Profile; 
  
  constructor(private router: Router, private authService: AuthService) { 
    this.username = 'user';
    this.profile = {
      username: '',
      age: 0,
      food: '',
      drink: ''
    };  
  } 
  // Suoritetaan aina kun komponentti latautuu muistiin 
  ngOnInit() {  
    this.username = localStorage.getItem('token');
    /* Haetaan tokenista saadun usernamen perusteella oikea profiili
       profiledata-tiedostosta tähän luokkaan */
    this.profile = Profiledata.filter(x => x.username === this.username)[0];     
  } 

  logout() {
    this.authService.isLoggedIn = false;  
    this.authService.removetoken();  
    this.router.navigate(['/login']);  
  } 

}
